﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using HeuristicLab.Core;
using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
using HeuristicLab.Common;

namespace HeuristicLab.Problems.NK.WeightInitializers {

  [Item("LinearWeightsInitializer", "Assigned linear increasing weights.")]
  public class LinearWeightsInitializer : NamedItem, IWeightsInitializer {

    public override bool CanChangeName { get { return false; } }
    public override bool CanChangeDescription { get { return false; } }

    [StorableConstructor]
    protected LinearWeightsInitializer(bool deserializing) : base(deserializing) { }
    protected LinearWeightsInitializer(LinearWeightsInitializer original, Cloner cloner)
      : base(original, cloner) {
    }
    public LinearWeightsInitializer() {
      name = ItemName;
      description = ItemDescription;
    }
    public override IDeepCloneable Clone(Cloner cloner) {
      return new LinearWeightsInitializer(this, cloner);
    }

    #region IWeightsInitializer Members

    public IEnumerable<double> GetWeights(int nComponents) {
      for (int i = 0; i<nComponents; i++)
        yield return i;
    }

    #endregion
  }

}
